import sys
import os
import re
import pathlib
import subprocess
from typing import List, Tuple, Callable, Dict
from enum import Enum

covers = [
    "portfolio-cover.jpg", 
    "cover-logo.jpg", 
    "cover-estrellita.jpg", 
    "cover-neocean.jpg", 
    "cover-orion.jpg", 
    "cover-cosmic.jpg", 
    "cover-elion.jpg", 
    "cover-fitnesso.jpg", 
    "cover-cloudwings.jpg", 
    "cover-lacasa.jpg", 
    "cover-mageko.jpg", 
    "cover-unfold.jpg",
    "cover-cico.jpg", 
    "cover-aisg.jpg", 
    "cover-qicycle.jpg", 
    "cover-qicycle-global.jpg", 
    "cover-iriding.jpg", 
    "cover-crumbs.jpg", 
    "cover-designer.jpg", 
    "cover-qicycle-computer.jpg", 
    # "cover-lyargoos.jpg", 
    # "cover-dogoos.jpg", 
    # "cover-pieson.jpg", 
    # "cover-jayne.jpg", 
    # "cover-resume-simple.jpg", 
    "portfolio-contact.jpg",
    "portfolio-rear.jpg", 
    ]
covers_with_space = [element for pair in zip(covers, ["spacer.png"] * len(covers)) for element in pair if element!= covers[-1] or pair[0] == covers[-1]]

commands = ["mkdir", "portfolio-pages"]
print(" ".join(commands))
subprocess.run(" ".join(commands), shell=True)

pdf_pages = []
idx = 0
for page in covers:
    idx += 1
    page_name = f"portfolio-pages/{idx}-{page}"
    commands = ["convert", page, "-resize", "1600x", page_name]
    print(" ".join(commands))
    subprocess.run(" ".join(commands), shell=True)
    pdf_pages.append(page_name)

commands = ["convert"] + pdf_pages + ["portfolio.pdf"]
print(" ".join(commands))
subprocess.run(" ".join(commands), shell=True)

# convert -size 1189x20 "xc:#d9d9d9" spacer.png
commands = ["convert", "-size", "1600x20", r'"xc:#FFFFFF"', "spacer.png"]
print(" ".join(commands))
subprocess.run(" ".join(commands), shell=True)

# convert 0.jpg spacer.png 1.jpg spacer.png 2.jpg spacer.png 3.jpg spacer.png 4.jpg spacer.png 5.jpg spacer.png 6.jpg -append resume-blueprint-shenyi_lee-zh.jpg
commands = ["convert"] + covers_with_space + ["-resize", "1600x", "-append", "portfolio.jpg"]
print(" ".join(commands))
subprocess.run(" ".join(commands), shell=True)

# convert resume-blueprint-shenyi_lee-zh.jpg -border 20x20 -bordercolor "#d9d9d9" resume-blueprint-shenyi_lee-zh.jpg
commands = ["convert", "portfolio.jpg", "-bordercolor", r'"#FFFFFF"', "-border", "20x20", "portfolio.jpg"]
print(" ".join(commands))
subprocess.run(" ".join(commands), shell=True)